package hitters.multi;

/**
 * @author Peter Fricke
 * 
 */
public class Parameter {

	private static final byte[][] deflt = { };
	
	private int L = 0;
	private int dimS;			// NICHT ändern! Erstmal fest, TODO: Dimensionen flexibilisieren
	private int dimI;			// NICHT ändern! Erstmal fest, TODO: Dimensionen flexibilisieren
	private byte[][] plength;   // = { {0,3,7,15,23,32} };  
	private int[][]  mask;      // { { 0x0, 0xF << 29, 0xFF << 25, 0xFFFF << 17, 0xFFFFFF << 9, 0xFFFFFFFF } };
	private final int stringCap = 9;
	//private int sysCap;

	private boolean mBug  =  false; // Bug im Pseudocode, siehe Kommentare instantiateDelta
	private boolean bProb =  false; // Bug im Paper S. 29, korrekt im Pseudocode
	private boolean optimizeOutput = true; //false;
	private Taxonomy taxonomy;


	public Parameter( int dimS ) {		
		this( dimS, deflt );					
	}
	
	public Parameter( int dimS, byte[][] plength ) {	
		this.dimS = dimS;
		this.dimI = plength.length;				
		this.mask = new int[dimI][]; 
		this.plength = new byte[dimI][];
		//sysCap = plength[dim - dimS].length -1;

		for( int d = 0; d < dimI; d++ ){			
			mask[d] = new int[ plength[d].length ];
			this.plength[d] = plength[d].clone();
			for( int i = 1; i < mask[d].length; i++ ){ 
				mask[d][i] = 0xFFFFFFFF << ( 32 - plength[d][i] );
				/* log( "Maske in dim " + d + " , i= "1 + i + " : "  );
				System.out.println( " 24 " + ((mask[d][i] & 0xff000000) >>> 24) );
				System.out.println( " 16 " + ((mask[d][i] & 0x00ff0000) >>> 16) );
				System.out.println( "  8 " + ((mask[d][i] & 0x0000ff00) >>>  8) );
				System.out.println( "  0 " + ((mask[d][i] & 0x000000ff)       ) ); */
			}	
		}
		
		try{
			taxonomy  = new Taxonomy("../resources/Taxonomy3");
		}catch(Exception e) { 
			//System.out.println("Kann die Datei resources/Taxonomy3 nicht finden.");

			try{
				taxonomy  = new Taxonomy("resources/Taxonomy3");
			}catch(java.io.FileNotFoundException ex) { 
				System.out.println("Kann die Datei resources/Taxonomy3 nicht finden.");
				System.out.print( ex.getMessage());
			};
		};	

		
	}


	public int getDimS() {
		return dimS;
	}

	public void setDimS(int dimS) {
		this.dimS = dimS;
	}

	public int getDimI() {
		return dimI;
	}

	public void setDimI(int dimI) {
		this.dimI = dimI;
	}

	public int getDim() {
		return dimI + dimS;
	}

	public int gethi( int dim ){
		if( dim < dimS ) return stringCap;
		else return plength[dim - dimS].length -1;
	}

	public int getL(){
		if( L == 0 ){			
			for( int i = 0; i < getDim(); i++) L += gethi( i ); 			
		}
		return L;
	}

	public byte[][] getPlength() {
		return plength;
	}

	public int getPlength( int dim, int index ) {
		return plength[dim][index];
	}

	public void setPlength(byte[][] plength) {
		this.plength = plength;
	}

	public int getWidth( int dim, int index ) {
		return plength[dim][index] - plength[dim][index-1]; 		
	}	

	public int getMask( int dim, int index ) {
		return mask[dim][index];
	}

	public int getMaskLength( int dim ) {
		return mask[dim].length;
	}

	public void setMask(int[][] mask) {
		this.mask = mask;
	}

	public int getStringCap() {
		return stringCap;
	}


	public boolean mBug() {
		return mBug;
	}


	public boolean bProb() {
		return bProb;
	}

	
	public void setMBug(boolean mBug) {
		this.mBug = mBug;
	}

	
	public void setBProb(boolean bProb) {
		this.bProb = bProb;
	}

	
	public void setOptimizeOutput(boolean optimizeOutput) {
		this.optimizeOutput = optimizeOutput;
	}


	public boolean optimizeOutput() {
		return optimizeOutput;
	}


	public String toString(){
		String s = "#\n# Dim = " + (dimI + dimS) + 
		", DimS = " + dimS + ", DimI = " + dimI +
		"\n# mBug = " + mBug + " bProb = " + bProb + 
		"\n# OptimizeHp = " + optimizeOutput + "\n#";
		//		for( int i = 0; i < getDim(); i++){
		//			s = s + " dim " + i + ": Hierarchietiefe " + gethi( i ) + "\n#"; 			
		//		}		
		return s;
	}


	public void setTaxonomy(Taxonomy taxonomy) {
		this.taxonomy = taxonomy;
	}


	public Taxonomy getTaxonomy() {
		return taxonomy;
	}
}
