/**
 * 
 */
package hitters.test;

import hitters.multi.Element;
import hitters.multi.HitterPolice;
import hitters.multi.MultiDatabase;
import hitters.multi.AbstractComplexHHH;
import hitters.multi.MultiHitterInfo;
import hitters.multi.Parameter;
import hitters.multi.PartAncHHH;
import hitters.tools.LogService;

import java.util.Date;
import java.util.HashMap;
import java.util.Vector;


/**
 * @author Peter Fricke
 * 
 */
public class SysCallExp {

	public static void main(String[] args) {

		String file = null;
		if( args.length > 0 )
			file = args[0].trim();		

		if( file == null ) file = "resources/testcase/ff1";		
		System.out.println( "Benutzte Datei " + file );
		boolean correct = true;
		for( int i = 0; i < 1; i++){
			if( ! testDatabaseReadSysCall( file, 0.02 * ( 1+i ), 0.01 * ( 1+i ) ) )
				correct = false;
		}
		System.out.println( "Probleme gefunden: " + (! correct) );
		LogService.logDBClose();
	}


	public static boolean testDatabaseReadSysCall( String file, double phi, double epsilon ) {

		//byte[][] plength = { {0,8,16,24,32}, {0,32} };		
		byte[][] plength = { {0,4,8,16,24,32} };
		Parameter myParams = new Parameter( 1, plength );
		AbstractComplexHHH fastPA = new PartAncHHH( epsilon, myParams );

		MultiDatabase d = new MultiDatabase( file, myParams );
		d.openRead();
		Vector<Element> data = d.readSystemCalls();	
		d.closeRead();	
		System.out.println( "Start: " + new Date() );
		System.out.println( "SIZE = " + data.size() );							
		System.out.println( "phi = " + phi + " epsilon = " + epsilon );
		Element element;
		for( int i = 0; i < data.size(); i++ ){
			element = data.elementAt( i ).clone();
			fastPA.insert( element, 1, true );			
		}

		System.out.println( "Tupel: = " + fastPA.getTupelCount() +
				" tupelMax " + fastPA.getMaxTupelCount() + " N= " + fastPA.getN() );
		System.out.println( "Stop Insert: " + new Date() );
		HashMap<Element, MultiHitterInfo> res;
		res = fastPA.outputSet( phi );		
		System.out.println( " Ergebnis für epsilon = " + epsilon + ", phi = " + phi + ": " );		
		for( Element h : res.keySet() ){		
			System.out.println( h + " " + res.get(h) );			
		}

		return  HitterPolice.check( file, fastPA, myParams, phi, true );			
	}	

}

