package hitters.test;

import static org.junit.Assert.*;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.HashMap;

import hitters.multi.Parameter;
import hitters.multi.SysElement;
import hitters.multi.SysParser;

import org.junit.Before;
import org.junit.Test;

/**
 * @author Peter Fricke
 * 
 */
public class SysParserTest {

	//byte[][] plength = { {0,16,32}, {0,32} };
	//byte[][] plength = { {0,16,32}, {0,16,32} };
	//byte[][] plength = { {0,32} };
	//byte[][] plength = { {0,8,16,24,28,32} };
	//byte[][] plength = { };
	byte[][] plength = { {0,4,8,16,24,32} };
	Parameter par;
	HashMap<Integer, String> fdTable;


	@Before
	public void setUp() throws Exception {

		par = new Parameter( 2 - plength.length, plength );				
		System.out.println(par);
		fdTable = new HashMap<Integer, String>(); 

	}


	@Test
	public void testCreateSystemCallElement() {

		BufferedReader in, res;
		SysElement el;
		String line, result;
		boolean problem = false;		

		try{ 			
			in  = new BufferedReader( new FileReader("resources/testcase/SysParserTest/Verona") );
			res = new BufferedReader( new FileReader("resources/testcase/SysParserTest/Verona.res") );

			while( (line = in.readLine()) != null ){      
				result = res.readLine();
				if( line.length() > 0 ){		
					el = SysParser.createSystemCallElement( line, fdTable, par );
					System.out.println( el.toString() );
					if( ! el.toString().equals( result.trim() ) ) problem = true;
				}
			}
		}
		catch (java.io.FileNotFoundException e){ 
			problem = true;
			System.out.print( e.getMessage() );			
		}
		catch (java.io.IOException e){
			problem = true;
			System.out.print( e.getMessage() );			
		}

		assertFalse( problem );

		//Massentest
		try{ 			
			in  = new BufferedReader( new FileReader("resources/testcase/ff1") );

			while( (line = in.readLine()) != null ){      				
				if( line.length() > 0 ){		
					el = SysParser.createSystemCallElement( line, fdTable, par );		  			
				}
			}
		}
		catch (java.io.FileNotFoundException e){ 
			problem = true;
			System.out.print( e.getMessage() );			
		}
		catch (java.io.IOException e){
			problem = true;
			System.out.print( e.getMessage() );			
		}

		assertFalse( problem );

	}

}
