package hitters.tools;

import java.io.*;

/**
 * @author Peter Fricke
 * 
 */
public class LogDatabase {

	private String filename;
	private FileWriter outData;
	private BufferedWriter out;
	private FileReader inData;
	private BufferedReader in;


	public LogDatabase( String filename ){
		this.filename = filename;
		this.openWrite();
	}


	public boolean openRead(){
		boolean success = true;
		try{ 
			inData = new FileReader(filename);
			in = new BufferedReader(inData);
		}
		catch (java.io.FileNotFoundException e){ 
			System.out.print(e.getMessage());
			success = false;
		}	    	    
		return success;
	}


	public void closeRead(){	    
		try{
			in.close();
		}
		catch (java.io.IOException e) {  };	    
	}


	public boolean openWrite(){
		boolean success = true;
		try{ 
			outData = new FileWriter(filename);
			out = new BufferedWriter(outData);
		}
		catch (java.io.FileNotFoundException e){ 
			System.out.print(e.getMessage());
			success = false;
		}
		catch (java.io.IOException e) { success = false; };

		return success;
	}


	public void closeWrite(){	    
		try{
			out.close();
		}
		catch (java.io.IOException e) {  };	    
	}


	public void println(String s) {
		try{ 
			out.write( s + System.getProperty("line.separator") );
		}
		catch (java.io.FileNotFoundException e){ 
			System.out.print(e.getMessage());		    	
		}
		catch (java.io.IOException e) { };
	}

}


